; Practica de ensamblador en relacion al funcionamiento del raton a bajo nivel
; Autor: Pablo de la Rosa
; E-Mail: kemih@softhome.net
; URL: http://kemih.tripod.com

; Ensamblar con TASM:
;	tasm raton
;	tlink raton

.model tiny
.stack 128h
.data
cr equ 13
lf equ 10
texto	db	cr,lf,"Las veces que has pulsado el raton son: ","$"

.code
inicio: 
        xor ax, ax	; Funcion 0 de la interrupcion 33h, resetear el driver del
        int 33h		; ratn y comprobar su estado.
        cmp ax, 0	; Si devuelve 0 no hay raton o su driver no esta instalado
        je fin		; Por consiguiente, terminar el programa.


bucle:
       mov     ah,86h	; Funcion 86 de la interrupcion 15h, hace esperar los segundos
       mov     cx,30	; guardados en CX:DX, es decir, en milisegundos, la parte alta
       mov     dx,00	; en CX y la baja en DX. Por consiguiente, esto espera tres segundos.
       int     15h
       
       mov ax, 5	; Funcion 5 de la interrupcion 33h, devuelve datos sobre la
       mov bx, 1	; pulsacion del boton derecho (bx = 1).
       int 33h			
       cmp bx, 1	; Devuelve en BX el nmero de veces que el boton fue pulsado
       jae fin		; desde la ultima llamada. Si solo fue pulsado una vez o ms,
       			; terminar el programa.

       mov ax, 5	; Funcion 5 de la interrupcion 33h, devuelve datos sobre la
       xor bx, bx	; pulsacion del boton izquierdo (bx = 0).
       int 33h
       cmp bx, 1	; Devuelve en BX el nmero de veces que el boton fue pulsado	
       jae mens		; desde la ultima llamada. Si fue pulsado una vez o ms,
       			; terminar el programa.
       jmp bucle	; Si no fue pulsado ninguna vez, volver a empezar el bucle.


mens: 

      mov ax, @data
      mov ds, ax
      mov dx, offset texto 	; Carga en DX el mensaje	
      mov ah, 9		; Funcion 9 de la interrupcion 21h, escribir una cadena que lee
      int 21h		; de DS:DX.
      add bx, 30h	; Suma 30h a las veces que se presiono el boton dado que los numeros
                        ; estan mapeados en la tabla ascii del 30h al 39h
      mov dl, bl	; Poner en DL el codigo ascii que queremos imprimir
      mov ah, 6		; Funcion 6 de la interrupcion 21h, escribir directamente un 
      int 21h		; caracter en la consola.
      		
fin:  
      mov ax, 4C00h	; Funcion 4C00h de la interrupcion 21h, terminar programa.
      int 21h

end inicio

